function x = lanczos2(v,H,z,kry_dim);
% 
% function x = lanczos2(v,H,z,kry_dim);
%
% Compute the approximation based on the already computed coefficients. 
%
% See also PHI_LAN, PHI_LAN_SYM.

% This file is part of the exp4 package available at
% http://na.uni-tuebingen.de.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% file COPYING of the distribution or send email to
% exp4@na.uni-tuebingen.de.

% assume norm_v=1

vk = v;
k = 1;
x = vk*z(1,:);

while  k < kry_dim

  % tmpv = A*vk;
  tmpv = odefun('Jacobian*v',vk);

  if k > 1 
    tmpv = tmpv - H(k-1,k)*vkm1 - H(k,k)*vk;
  else
    tmpv = tmpv - H(k,k)*vk;
  end
  vkm1 = vk;
  vk   = tmpv/H(k+1,k);
%  fprintf('lanczos2: used entry %2.0f,%2.0f of H\n',k+1,k);

  k = k + 1;

  x = x + vk*z(k,:);
end    
